btrfs: Add new test for qgroup assign functionality
[xfstests-dev.git] / check
diff --git a/check b/check
index 3de1f08676e8f53183257e136b279053045a5099..415e0ff326f50824591e98de6853cc59e09cd091 100755 (executable)
--- a/check
+++ b/check
@@ -22,9 +22,11 @@ have_test_arg=false
 randomize=false
 export here=`pwd`
 xfile=""
+subdir_xfile=""
 brief_test_summary=false
 do_report=false
 DUMP_OUTPUT=false
+iterations=1
 
 # This is a global variable used to pass test failure text to reporting gunk
 _err_msg=""
@@ -51,19 +53,21 @@ usage()
     echo "Usage: $0 [options] [testlist]"'
 
 check options
-    -nfs                test NFS
-    -glusterfs                test GlusterFS
-    -cifs               test CIFS
+    -nfs               test NFS
+    -glusterfs         test GlusterFS
+    -cifs              test CIFS
     -9p                        test 9p
+    -virtiofs          test virtiofs
     -overlay           test overlay
-    -pvfs2          test PVFS2
-    -tmpfs              test TMPFS
-    -ubifs              test ubifs
+    -pvfs2             test PVFS2
+    -tmpfs             test TMPFS
+    -ubifs             test ubifs
     -l                 line mode diff
     -udiff             show unified diff (default)
     -n                 show me, do not run tests
     -T                 output timestamps
     -r                 randomize test order
+    -i <n>             iterate the test list <n> times
     -d                 dump test output to stdout
     -b                 brief test summary
     -R fmt[,fmt]       generate report in formats specified. Supported format: [xunit]
@@ -129,6 +133,7 @@ get_group_list()
        local grp=$1
        local grpl=""
        local sub=$(dirname $grp)
+       local fsgroup="$FSTYP"
 
        if [ -n "$sub" -a "$sub" != "." -a -d "$SRC_DIR/$sub" ]; then
                # group is given as <subdir>/<group> (e.g. xfs/quick)
@@ -137,7 +142,10 @@ get_group_list()
                return
        fi
 
-       for d in $SRC_GROUPS $FSTYP; do
+       if [ "$FSTYP" = ext2 -o "$FSTYP" = ext3 ]; then
+           fsgroup=ext4
+       fi
+       for d in $SRC_GROUPS $fsgroup; do
                if ! test -d "$SRC_DIR/$d" ; then
                        continue
                fi
@@ -241,13 +249,17 @@ _prepare_test_list()
        done
 
        # sort the list of tests into numeric order
-       list=`sort -n $tmp.list | uniq`
-       rm -f $tmp.list
-
-       if $randomize
-       then
-               list=`echo $list | awk -f randomize.awk`
+       if $randomize; then
+               if type shuf >& /dev/null; then
+                       sorter="shuf"
+               else
+                       sorter="awk -v seed=$RANDOM -f randomize.awk"
+               fi
+       else
+               sorter="cat"
        fi
+       list=`sort -n $tmp.list | uniq | $sorter`
+       rm -f $tmp.list
 }
 
 # Process command arguments first.
@@ -259,6 +271,7 @@ while [ $# -gt 0 ]; do
        -glusterfs)     FSTYP=glusterfs ;;
        -cifs)          FSTYP=cifs ;;
        -9p)            FSTYP=9p ;;
+       -virtiofs)      FSTYP=virtiofs ;;
        -overlay)       FSTYP=overlay; export OVERLAY=true ;;
        -pvfs2)         FSTYP=pvfs2 ;;
        -tmpfs)         FSTYP=tmpfs ;;
@@ -272,13 +285,7 @@ while [ $# -gt 0 ]; do
                XGROUP_LIST="$XGROUP_LIST ${xgroup//,/ }"
                ;;
 
-       -X)     xfile=$2; shift ;
-               for d in $SRC_GROUPS $FSTYP; do
-                       [ -f $SRC_DIR/$d/$xfile ] || continue
-                       for f in `sed "s/#.*$//" $SRC_DIR/$d/$xfile`; do
-                               echo $d/$f >> $tmp.xlist
-                       done
-               done
+       -X)     subdir_xfile=$2; shift ;
                ;;
        -E)     xfile=$2; shift ;
                if [ -f $xfile ]; then
@@ -292,7 +299,7 @@ while [ $# -gt 0 ]; do
 
        -n)     showme=true ;;
         -r)    randomize=true ;;
-
+       -i)     iterations=$2; shift ;;
        -T)     timestamp=true ;;
        -d)     DUMP_OUTPUT=true ;;
        -b)     brief_test_summary=true;;
@@ -325,6 +332,15 @@ if ! . ./common/rc; then
        exit 1
 fi
 
+if [ -n "$subdir_xfile" ]; then
+       for d in $SRC_GROUPS $FSTYP; do
+               [ -f $SRC_DIR/$d/$subdir_xfile ] || continue
+               for f in `sed "s/#.*$//" $SRC_DIR/$d/$subdir_xfile`; do
+                       echo $d/$f >> $tmp.xlist
+               done
+       done
+fi
+
 # Process tests from command line now.
 if $have_test_arg; then
        while [ $# -gt 0 ]; do
@@ -475,9 +491,8 @@ _check_filesystems()
        if [ -f ${RESULT_DIR}/require_scratch ]; then
                _check_scratch_fs || err=true
                rm -f ${RESULT_DIR}/require_scratch*
-       else
-               _scratch_unmount 2> /dev/null
        fi
+       _scratch_unmount 2> /dev/null
 }
 
 _expunge_test()
@@ -492,7 +507,18 @@ _expunge_test()
        return 0
 }
 
-_init_kmemleak
+# Make the check script unattractive to the OOM killer...
+OOM_SCORE_ADJ="/proc/self/oom_score_adj"
+test -w ${OOM_SCORE_ADJ} && echo -1000 > ${OOM_SCORE_ADJ}
+
+# ...and make the tests themselves somewhat more attractive to it, so that if
+# the system runs out of memory it'll be the test that gets killed and not the
+# test framework.
+_run_seq() {
+       bash -c "test -w ${OOM_SCORE_ADJ} && echo 250 > ${OOM_SCORE_ADJ}; exec ./$seq"
+}
+
+_detect_kmemleak
 _prepare_test_list
 
 if $OPTIONS_HAVE_SECTIONS; then
@@ -501,7 +527,10 @@ else
        trap "_wrapup; exit \$status" 0 1 2 3 15
 fi
 
-for section in $HOST_OPTIONS_SECTIONS; do
+function run_section()
+{
+       local section=$1
+
        OLD_FSTYP=$FSTYP
        OLD_TEST_FS_MOUNT_OPTS=$TEST_FS_MOUNT_OPTS
        get_next_config $section
@@ -516,7 +545,7 @@ for section in $HOST_OPTIONS_SECTIONS; do
                        fi
                done
                if $skip; then
-                       continue
+                       return
                fi
        fi
 
@@ -530,10 +559,17 @@ for section in $HOST_OPTIONS_SECTIONS; do
                        fi
                done
                if $skip; then
-                       continue
+                       return
                fi
        fi
 
+       mkdir -p $RESULT_BASE
+       if [ ! -d $RESULT_BASE ]; then
+               echo "failed to create results directory $RESULT_BASE"
+               status=1
+               exit
+       fi
+
        if $OPTIONS_HAVE_SECTIONS; then
                echo "SECTION       -- $section"
        fi
@@ -603,13 +639,15 @@ for section in $HOST_OPTIONS_SECTIONS; do
 
          # call the overridden mount - make sure the FS mounts with
          # the same options that we'll mount with later.
-         if ! _scratch_mount >$tmp.err 2>&1
+         if ! _try_scratch_mount >$tmp.err 2>&1
          then
              echo "our local mount routine ..."
              cat $tmp.err
              echo "check: failed to mount \$SCRATCH_DEV using specified options"
              status=1
              exit
+         else
+             _scratch_unmount
          fi
        fi
 
@@ -667,6 +705,8 @@ for section in $HOST_OPTIONS_SECTIONS; do
                seqres="$REPORT_DIR/$seqnum"
 
                mkdir -p $RESULT_DIR
+               rm -f ${RESULT_DIR}/require_scratch*
+               rm -f ${RESULT_DIR}/require_test*
                echo -n "$seqnum"
 
                if $showme; then
@@ -722,12 +762,18 @@ for section in $HOST_OPTIONS_SECTIONS; do
                        # _check_dmesg depends on this log in dmesg
                        touch ${RESULT_DIR}/check_dmesg
                fi
+               _try_wipe_scratch_devs > /dev/null 2>&1
+
+               # clear the WARN_ONCE state to allow a potential problem
+               # to be reported for each test
+               (echo 1 > $DEBUGFS_MNT/clear_warn_once) > /dev/null 2>&1
+
                if [ "$DUMP_OUTPUT" = true ]; then
-                       ./$seq 2>&1 | tee $tmp.out
+                       _run_seq 2>&1 | tee $tmp.out
                        # Because $? would get tee's return code
                        sts=${PIPESTATUS[0]}
                else
-                       ./$seq >$tmp.out 2>&1
+                       _run_seq >$tmp.out 2>&1
                        sts=$?
                fi
 
@@ -754,15 +800,29 @@ for section in $HOST_OPTIONS_SECTIONS; do
                        _dump_err_cont "[failed, exit status $sts]"
                        _test_unmount 2> /dev/null
                        _scratch_unmount 2> /dev/null
+                       rm -f ${RESULT_DIR}/require_test*
+                       rm -f ${RESULT_DIR}/require_scratch*
                        err=true
                else
                        # the test apparently passed, so check for corruption
                        # and log messages that shouldn't be there.
                        _check_filesystems
                        _check_dmesg || err=true
-                       _check_kmemleak || err=true
                fi
 
+               # Reload the module after each test to check for leaks or
+               # other problems.
+               if [ -n "${TEST_FS_MODULE_RELOAD}" ]; then
+                       _test_unmount 2> /dev/null
+                       _scratch_unmount 2> /dev/null
+                       modprobe -r fs-$FSTYP
+                       modprobe fs-$FSTYP
+               fi
+
+               # Scan for memory leaks after every test so that associating
+               # a leak to a particular test will be as accurate as possible.
+               _check_kmemleak || err=true
+
                # test ends after all checks are done.
                $timestamp && _timestamp
                stop=`_wallclock`
@@ -819,6 +879,12 @@ for section in $HOST_OPTIONS_SECTIONS; do
 
        _test_unmount 2> /dev/null
        _scratch_unmount 2> /dev/null
+}
+
+for ((iters = 0; iters < $iterations; iters++)) do
+       for section in $HOST_OPTIONS_SECTIONS; do
+               run_section $section
+       done
 done
 
 interrupt=false